USE master
GO
If db_id(N'FlowerShop') IS NOT NULL
BEGIN
DROP DATABASE FlowerShop
END
GO
CREATE DATABASE FlowerShop
GO
USE FlowerShop
GO
CREATE TABLE ACCOUNT(
	USERNAME VARCHAR(50) NOT NULL PRIMARY KEY,
    PASSWORD VARCHAR(50) NOT NULL,
    ROLE INT NOT NULL
)
GO

CREATE TABLE EMPLOYEE(
	ID int IDENTITY(1,1)NOT NULL PRIMARY KEY,
	USERNAME varchar(50)NOT NULL,
	PASSWORD varchar(50)NOT NULL,
	ROLE int NOT NULL,
	NAME nvarchar(50)NOT NULL,
	TELEPHONE int NULL,
	ADDRESS nvarchar(150) NOT NULL

)
GO
CREATE TABLE [RANK](
	ID int IDENTITY(1,1) NOT NULL PRIMARY KEY,
	POSITION nvarchar(50)NOT NULL
)
GO
CREATE TABLE CUSTOMER(
	ID int IDENTITY(1,1)NOT NULL PRIMARY KEY,
	USERNAME varchar(50)NOT NULL,
	PASSWORD varchar(50)NOT NULL,
    ROLE INT NOT NULL,
	[RANK] int NOT NULL,
	NAME nvarchar(50)NOT NULL,
	TELEPHONE int NULL,
	ADDRESS nvarchar(150) NOT NULL
UNIQUE (USERNAME),
	FOREIGN KEY ([RANK]) REFERENCES [RANK](ID) ON UPDATE CASCADE,

)
GO
CREATE TABLE CATEGORY(
	ID int IDENTITY(1,1) NOT NULL PRIMARY KEY,
	TYPE nvarchar(50)NOT NULL,
	UNIQUE (TYPE)
)
GO
CREATE TABLE PRODUCT(
	ID nvarchar(50)NOT NULL PRIMARY KEY,
	NAME nvarchar(50) NOT NULL,
	PRICE int NOT NULL,
	CATEGORY int NOT NULL,
	QUANTITY int NULL,
	UNIQUE (NAME),
	FOREIGN KEY (CATEGORY) REFERENCES CATEGORY(ID)ON UPDATE CASCADE
)
GO
CREATE TABLE ROTATIONTYPE(
	ID int IDENTITY(1,1)NOT NULL PRIMARY KEY,
	TYPE nvarchar(50)NOT NULL,
	UNIQUE (TYPE)
)
GO
CREATE TABLE ROTATION(
	ID int IDENTITY(1,1)NOT NULL PRIMARY KEY,
	PRODUCTID nvarchar(50)NOT NULL,
	QUANTITY int NOT NULL,
	DATE date NULL,
	ROTATION int NOT NULL,
	FOREIGN KEY (PRODUCTID) REFERENCES PRODUCT(ID)ON UPDATE CASCADE,
	FOREIGN KEY (ROTATION)REFERENCES ROTATIONTYPE(ID)ON UPDATE CASCADE
)
GO
CREATE TABLE BILL(
	ID int IDENTITY(1,1) NOT NULL PRIMARY KEY,
	NAME nvarchar(50)NULL,
	TELEPHONE int NULL,
	ADDRESS nvarchar(150)NULL,
	DATE date NOT NULL
)
GO
CREATE TABLE BILLDETAIL(
	BILLID int NOT NULL,
	PRODUCTID nvarchar(50)NOT NULL,
	QUANTITY int NOT NULL,
	PRIMARY KEY (BILLID, PRODUCTID),
UNIQUE(BILLID, PRODUCTID),
	FOREIGN KEY (BILLID) REFERENCES BILL(ID)ON UPDATE CASCADE,
	FOREIGN KEY (PRODUCTID)REFERENCES PRODUCT(ID)
)
GO
CREATE TABLE [ORDER](
	ID int IDENTITY(1,1)NOT NULL PRIMARY KEY,
	NAME nvarchar(50)NOT NULL,
	TELEPHONE int NOT NULL,
	ADDRESS nvarchar(150)NOT NULL,
	DATE date NOT NULL
)
GO
CREATE TABLE ORDERDETAIL(
	ORDERID int NOT NULL,
	PRODUCTID nvarchar(50)NOT NULL,
	QUANTITY int NOT NULL,
	PRIMARY KEY (ORDERID, PRODUCTID),
UNIQUE(ORDERID, PRODUCTID),
	FOREIGN KEY (ORDERID)REFERENCES [ORDER](ID)ON UPDATE CASCADE,
	FOREIGN KEY (PRODUCTID)REFERENCES PRODUCT(ID)ON UPDATE CASCADE
)
